# The model has already been created by the framework, and extends Rhom::RhomObject
# You can add more methods here
class Friend
  include Rhom::PropertyBag
   
  def self.empty?
    return find(:all).empty?
  end
  
  def self.get_today_friends_array(friends)
    friends_by_date = []
    friends_by_date = friends.find_all {|friend| friend.created_at == Time.now.strftime('%m/%d') }
  end

  def self.get_older_friends_array(friends)
    friends_by_date = []
    friends_by_date = friends.find_all {|friend| friend.created_at != Time.now.strftime('%m/%d') }
  end

  def  self.build_friends_hash_from_fousquare(friend)
    created_at = Date.parse(friend["created"]).strftime('%m/%d')
    comment = friend["shout"] || ""
    photo = friend["user"]["photo"]
    friend_at_place = friend["display"] || ""
    friend_from = "/public/images/fs_logo.png"
    attributes_hash = {:created_at => created_at, :comment => comment, :photo => photo, :friend_at_place => friend_at_place, :friend_from => friend_from }
    return attributes_hash
  end

  def self.build_friends_hash_from_brightkite(friend)
    created_at = Date.parse(friend['last_checked_in']).strftime('%m/%d')
    comment = ""
    photo = friend['smaller_avatar_url']
    friend_at_place = ""
    friend_at_place = friend['login'] + " @ " + friend['place']['name'] 
    friend_from = "/public/images/bk_logo.png"
    attributes_hash = {:created_at => created_at, :comment => comment, :photo => photo, :friend_at_place => friend_at_place, :friend_from => friend_from }
    return attributes_hash
  end
  
  def self.get_friends_hash(params, service)
    friends_hash = []
    if service == 'foursquare' and params['checkins']
      params['checkins'].each do |friend|
        friends_hash << build_friends_hash_from_fousquare(friend)
      end
    elsif service == 'brightkite' && params
      params.each do |friend|
        friends_hash << build_friends_hash_from_brightkite(friend)
      end
    end
    return friends_hash
  end
  
  def self.save_friends(friends)
    friends.each do |friend|
      f = new(friend)
      f.save
    end
  end
  
  def self.merge_friends(friends_hash)
    store_friends = find(:all)
    store_friends.each do |friend|
      friend_hash_found = friends_hash.detect {|friend_hash| friend_hash[:friend_at_place] == friend.friend_at_place}
      if friend_hash_found
        friends_hash.delete(friend_hash_found)
      end
    end
    
    friends_hash.each do |friend_hash|
      new_friend = new(friend_hash)
      new_friend.save
    end
  end
end
