require 'rho/rhocontroller'
require 'helpers/browser_helper'

class LocationController < Rho::RhoController
  include BrowserHelper

  def create
    Location.delete_all
    Place.delete_all
    @location = Location.new(@params['location'])
    @location.save
    Rho::AsyncHttp.get(
      :url => "http://maps.google.com/maps/api/geocode/json?address=#{@location.zipcode}&sensor=false",
      :callback => (url_for :action => :location_callback))
  end
  
  def location_callback
    @location = Location.find(:first)
    
    if @params["body"]["status"] == "OK"
      @location.lat = @params["body"]["results"][0]["geometry"]["location"]["lat"]
      @location.long = @params["body"]["results"][0]["geometry"]["location"]["lng"]
      @location.save
      WebView.execute_js("$('.zipcode_form .spinner').hide(); $('.new_zipcode').hide(); $('.zipcode_form').hide(); $('.zip_error').hide(); $('.zipcode li span').text('#{@location.zipcode}'); $.get('/app/Place/get_nearby_places');", 0)
    else
      @location.destroy
      WebView.execute_js("$('.zipcode_form .spinner').hide(); $('.zip_error').show(); $('.zipcode_form form').show();", 0)
    end
  end
  
  def update_location
    @location = Location.find(:first)
    if @location
      WebView.execute_js("$('.new_zipcode').hide(); $('.zipcode_form').hide();",0)
    else
      WebView.execute_js("$('.new_zipcode').hide(); $('.zipcode_form').hide(); $('.zipcode_form .spinner').show(); $.get('/app/Place/get_nearby_places');", 0)
    end
  end
  
  def new
    render :action => :new
  end
end
