# The model has already been created by the framework, and extends Rhom::RhomObject
# You can add more methods here
class User
  include Rhom::PropertyBag
  
  #add model specifc code here
  
  def self.uncheck_all
    users = find(:all)
    users.each {|u| u.checked = "false"; u.save}
  end
  
  def self.mark_as_checked_checkin
    find(:all).each {|user| user.check_ins = "false"; user.save}
  end
  
  def self.unchecked_check_in
    users_check_in = find(:all)
    users_check_in.each {|user| user.checked_check_in = check_in?(user.service, false); user.save}
  end
  
  def self.unchecked_friends
    users_friends = find(:all)
    users_friends.each {|user| user.friends = friends?(user.service, false); user.save}
  end
  
  def self.check_in?(service, value)
    if service == 'foursquare'
      return "#{value}"
    elsif service == 'brightkite'
      return "#{value}"
    else
      return "#{!value}"
    end
  end
  
  def self.friends?(service, value)
    if service == 'foursquare'
      return "#{value}"
    elsif service == 'brightkite'
      return "#{value}"
    else
      return "#{!value}"
    end
  end
  
  def self.build_from_params(params)
    if params['service'] == "foursquare"
      photo = params['body']['user']['photo']
      name = params['body']['user']['firstname'] + " " + params['body']['user']['lastname']
    elsif params['service'] == "gowalla"
      photo = params['body']['image_url']
      name = params['body']['first_name'] + " " + params['body']['last_name']
    elsif
      photo = params['body']['small_avatar_url']
      name = params['body']['fullname']
    else
      photo = ""
      name = ""
    end
    
    checked_check_in = check_in?(params['service'], false)
    friends = friends?(params['service'], false)
    
    new({:service => params['service'], 
        :login => params['login'], 
        :password => params['password'], 
        :checked => "false", 
        :check_ins => "false",
        :checked_check_in => checked_check_in,
        :friends => friends,
        :photo => photo,
        :name => name,
        :last_check_friends => (Time.now-(20*60)).strftime("%I:%M") })
  end
  
  def self.reload_friends?
    users = find(:all)
    user_not_reloaded_recently = users.detect{|user| user.last_check_friends < (Time.now-(10*60)).strftime("%I:%M") }
    puts "AAA: users in reload friends #{user_not_reloaded_recently.inspect}"
    return true if user_not_reloaded_recently
    return false
  end
  
end
