require 'rho/rhocontroller'
require 'helpers/browser_helper'

class UserController < Rho::RhoController
  include BrowserHelper

  def new
    @msg = @params['msg'] || ''
    @service = @params['service'] || ''
    puts "AAAA: New User, Service: #{@service}"
    @g_user = User.find(:first, :conditions => {:service => "gowalla"})
    @f_user = User.find(:first, :conditions => {:service => "foursquare"})
    @b_user = User.find(:first, :conditions => {:service => "brightkite"})
  end
  
  def create
    puts "AAAA: Params before login: #{@params}"
    @user = User.new(@params['user'])
    puts "AAAA: User info #{@user.inspect}, url #{user_url(@user)}"
    Rho::AsyncHttp.get(
      :url => user_url(@user),
      :callback => (url_for :action => :validate_credentials),
      :headers => {'User-Agent' => Rho::RhoConfig.user_agent},
      :callback_param => "service=#{@user.service}&login=#{@user.login}&password=#{@user.password}",
      :authentication => {:type => :basic, :username => @user.login, :password => @user.password} )
    
    #WebView.navigate(url_for(:controller => :Settings, :action => 'wait'), 2)
  end
  
  def validate_credentials
    puts "AAAAA: Params validate_credentials: #{@params.inspect}"
    errCode = @params['error_code'].to_i
    if errCode == 0
      @user = User.build_from_params(@params)
      @user.save
      Place.delete_all
      puts "AAAA: User guardado: #{@user.inspect}, all users #{User.find(:all)}"
      #NativeBar.create(Rho::RhoApplication::TABBAR_TYPE, tabs) if User.find(:all).size == 1
      #NativeBar.switch_tab(2)
      #puts "AAAA: Native bar created"
      WebView.navigate(url_for(:action => :new, :query => {:service => @user.service}), 2)
      puts "AAAA: Going to new user with a user"
    else
      WebView.navigate(url_for(:action => :new, :query => {:service => @params['service'], :msg => "Login or password for #{@params['service']} are invalid"}), 2)
    end
  end
  
  def destroy
    @user = User.find(@params['id'])
    @user.destroy if @user
    Place.delete_all
    Location.delete_all
    Friend.delete_all
    puts "AAAA: Destroy, service: #{@params['service']}"
    #redirect(:action => :new, :query => {:service => "#{@params['service']}"})
    WebView.navigate(url_for(:action => :new, :query => {:service => @params['service']}), 2)
    #NativeBar.remove if users.empty?
  end

end
